ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.7 by root, Sun Mar 11 20:37:04 2007 UTC vs.
Revision 1.95 by root, Wed Oct 6 00:19:32 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hash collision, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
80} 159}
81 160
161our @WALL_SUFFIX = qw(⬤ ╹ ╺ ┗ ╻ ┃ ┏ ┣ ╸ ┛ ━ ┻ ┓ ┫ ┳ ╋);
162
163sub autoglyph {
164 my ($stem, $face) = @_;
165
166 if ($stem =~ /^wall\/|Nimwall/) {
167 return $WALL_SUFFIX[hex $1]
168 if $stem =~ /(_[0-9A-F]).x11/;
169
170 "+"
171
172 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
173 "."
174
175 } elsif ($stem =~ /^player\//) {
176 "\@"
177
178 } else {
179 substr $stem, 0, 1
180 }
181}
182
82{ 183{
83 our %PNG32; 184 our %ANIMINFO;
84 our %FACEINFO; 185 our %FACEINFO;
186 our %RESOURCE;
85 our @ARC; 187 our @ARC;
188 our %ARC;
189 our $TRS;
86 our $NFILE; 190 our $NFILE;
87 our %ANIM; 191 our $PATH;
88 192
89 our (@png, @trs, @arc); # files we are interested in 193 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 194
195 our $c_arc = new Coro::Channel;
196 our $c_trs = new Coro::Channel;
197 our $c_res = new Coro::Channel;
198
199 our @c_png;
200
91 sub commit_png { 201 sub commit_png($$$$) {
92 my ($name, $data) = @_; 202 my ($stem, $name, $data, $T) = @_;
93 203
94 $PNG32{$name} = $data; 204 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
95 $FACEINFO{$name} ||= {}; 205 $FACEINFO{$name}{"data$T"} = $data;
96 } 206 }
97 207
98 sub process_png { 208 sub process_png {
99 while (@png) { 209 while (@c_png) {
100 my $path = pop @png; 210 my ($path, $delete) = @{pop @c_png};
101 211
102 my $png; 212 my $png;
103 aio_lstat $path; 213 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 214 my ($size, $mtime) = (stat _)[7,9];
105 215
106 if (0 > aio_load $path, $png) { 216 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 217 warn "$path: $!, skipping.\n";
108 next; 218 next;
109 } 219 }
110 220
221 my $stem = $path;
222 my $T;
223
224 if ($stem =~ s/\.32x32\.png~?$//) {
225 $T = 32;
226 } elsif ($stem =~ s/\.64x64\.png~?$//) {
227 $T = 64;
228 } else {
229 warn "$path: weird filename, skipping.\n";
230 next;
231 }
232
111 # quickly extract width and height of the (necessarily PNG) image 233 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 234 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 235 warn "$path: not a recognized png file, skipping.\n";
114 next; 236 next;
115 } 237 }
116 238
117 my ($w, $h) = unpack "NN", $1; 239 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 240
127 if ($w < $T || $h < $T) { 241 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 242 warn "$path: too small ($w $h), skipping.\n";
129 next; 243 next;
130 } 244 }
132 if ($w % $T || $h % $T) { 246 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 247 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 248 next;
135 } 249 }
136 250
251 (my $base = $stem) =~ s/^.*\///;
252
253 my $fi = $FACEINFO{$base};
254 unless ($fi) {
255 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
256 #next;
257 }
258
259 my $arc = $fi->{arc} || { };
260
261 unless ($path =~ /~$/) {
262 # possibly enlarge
263 if (0 > aio_stat "$stem.64x64.png") {
264 my $other = "$stem.64x64.png~";
265
266 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
267 fork_sub {
268 my $CROP;
269 my $SRC = "png:\Q$path\E";
270
271 my $is_floor = $arc->{is_floor};
272 my $is_wall = 0;
273
274 my ($wall_pfx, $wall_dir, $wall_sfx);
275
276 if (
277 !$is_floor
278 && !$arc->{alive}
279 && $arc->{move_block} eq "all"
280 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
281 ) {
282 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
283
284 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
285 $is_wall = 1;
286 }
287 }
288
289 if ($is_wall || $is_floor) {
290 # add a 4px border and add other images around it
291 $CROP = "-shave 8x8 +repage";
292
293 $w += 8;
294 $h += 8;
295
296 $SRC = "-size ${w}x${h} xc:transparent";
297 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
298
299 # 8 surrounding images
300 for (
301 # x y b r0 r1
302 [-1, -1, 0, 6],
303 [ 0, -1, 1, 10, 14],
304 [+1, -1, 0, 12],
305
306 [-1, 0, 8, 5, 7],
307 #
308 [+1, 0, 2, 5, 13],
309
310 [-1, +1, 0, 3],
311 [ 0, +1, 4, 10, 11],
312 [+1, +1, 0, 9],
313 ) {
314 my ($x, $y, $d, $r0, $r1) = @$_;
315
316 my $tile = $is_floor ? $path
317 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
318 : die;
319
320 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
321 "\Q$tile",
322 $x * ($w - 8) + 4,
323 $y * ($h - 8) + 4;
324 }
325 }
326
327 system "convert -depth 8 $SRC rgba:-"
328 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
329 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
330 and die "convert/cfhq2xa pipeline error: status $? ($!)";
331 system $OPTIPNG, "-i0", "-q", "$other~";
332 die "$other~ has zero size, aborting." unless -s "$other~";
333 rename "$other~", $other;
334 };
335 }
336
337 push @c_png, [$other, !$CACHE];
338 }
339
340 # possibly scale down
341 if (0 > aio_stat "$stem.32x32.png") {
342 my $other = "$stem.32x32.png~";
343
344 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
345 fork_sub {
346 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
347 system $OPTIPNG, "-i0", "-q", "$other~";
348
349 # reduce smoothfaces >10000 bytes
350 # obsolete, no longer required
351 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
352 my $ncolor = 256;
353 while () {
354 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
355 system $OPTIPNG, "-i0", "-q", "$other~~";
356 last if 10000 > -s "$other~~";
357 $ncolor = int $ncolor * 0.9;
358 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
359 }
360
361 printf "reduced %s from %d to %d bytes using %d colours.\n",
362 $other, -s "$other~", -s "$other~~", $ncolor
363 if $VERBOSE >= 2;
364 rename "$other~~", "$other~";
365 }
366
367 die "$other~ has zero size, aborting." unless -s "$other~";
368 rename "$other~", $other;
369 };
370 }
371
372 #warn "scaled down $path to $other\n";#d#
373 push @c_png, [$other, !$CACHE];
374 }
375 }
376
377 (my $face = $stem) =~ s/^.*\///;
378
379 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 380 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 381 # split
139 my @tile; 382 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 383 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 384 for my $y (0 .. (int $h / $T) - 1) {
155 ( 398 (
156 "(", 399 "(",
157 "+clone", 400 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 401 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 402 "+repage",
403 -quality => "00",
160 -write => "png:$_->[2]~", 404 -write => "png32:$_->[2]~",
161 "+delete", 405 "+delete",
162 ")", 406 ")",
163 ) 407 )
164 } @todo), 408 } @todo),
165 "null:"; 409 "null:";
169 close $convert; 413 close $convert;
170 414
171 # pass 2, optimise, and rename 415 # pass 2, optimise, and rename
172 for (@todo) { 416 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 417 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
418 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 419 rename "$_->[2]~", $_->[2];
175 } 420 }
176 }; 421 };
177 } 422 }
178 423
182 427
183 if (0 > aio_load $file, $tile) { 428 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 429 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 430 }
186 IO::AIO::aio_unlink $file unless $CACHE; 431 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 432 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 433 }
189 } else { 434 } else {
190 # use as-is (either small, use smooth) 435 # use as-is (either small, use smooth)
191 commit_png $face, $png; 436 commit_png $stem, $face, $png, $T;
192 } 437 }
438
439 aio_unlink $path if $delete;
193 } 440 }
194 } 441 }
195 442
196 sub process_arc { 443 sub process_arc {
197 while (@arc) { 444 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 445 my ($dir, $file) = @$job;
199 446
200 my $arc; 447 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 448 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 449
203 my $arc = read_arch "$dir/$file"; 450 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 451 for my $o (values %$arc) {
205 push @ARC, $o; 452 push @ARC, $o;
453 for (my $m = $o; $m; $m = $m->{more}) {
454 $ARC{$m->{_name}} = $m;
455 }
456
457 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
206 458
207 my $visibility = delete $o->{visibility}; 459 my $visibility = delete $o->{visibility};
208 my $magicmap = delete $o->{magicmap}; 460 my $magicmap = delete $o->{magicmap};
461 my $glyph = delete $o->{glyph};
209 462
210 # find upper left corner :/ 463 # find upper left corner :/
211 # omg, this is sooo broken 464 # omg, this is sooo broken
212 my ($dx, $dy); 465 my ($dx, $dy);
213 for (my $o = $o; $o; $o = $o->{more}) { 466 for (my $o = $o; $o; $o = $o->{more}) {
219 my $x = $o->{x} - $dx; 472 my $x = $o->{x} - $dx;
220 my $y = $o->{y} - $dy; 473 my $y = $o->{y} - $dy;
221 474
222 my $ext = $x|$y ? "+$x+$y" : ""; 475 my $ext = $x|$y ? "+$x+$y" : "";
223 476
224 $o->{face} .= $ext; 477 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
225 478
226 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 479 $visibility = delete $o->{visibility} if exists $o->{visibility};
227 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 480 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
481 $glyph = delete $o->{glyph} if exists $o->{glyph};
228 482
229 my $anim = delete $o->{anim}; 483 my $anim = delete $o->{anim};
230 484
231 if ($anim) { 485 if ($anim) {
486 # possibly add $ext to the animation name to avoid
487 # the need to specify archnames for all parts
488 # of a multipart archetype.
232 $o->{animation} = "$o->{_name}$ext"; 489 $o->{animation} = "$o->{_name}";
490 my $facings = 1;
491 my @frames;
233 492
234 for (@$anim) { 493 for (@$anim) {
235 $_ .= $ext unless /^facings\s/; 494 if (/^facings\s+(\d+)/) {
495 $facings = $1*1;
496 } elsif (/^blank.x11$|^empty.x11$/) {
497 push @frames, $_;
498 } else {
499 push @frames, "$_$ext";
500 }
236 } 501 }
237 502
238 $ANIM{"$o->{_name}$ext"} = 503 $ANIMINFO{$o->{animation}} = {
239 join "", map "$_\n", 504 facings => $facings,
240 "anim $o->{_name}$ext", 505 frames => \@frames,
241 @$anim, 506 };
242 "mina";
243 } 507 }
244 508
245 for my $face ($o->{face} || (), @{$anim || []}) { 509 for ($o->{face} || (), @{$anim || []}) {
246 next if /^facings\s/; 510 next if /^facings\s/;
247 511
512 my $face = $_;
513 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
514
248 my $info = $FACEINFO{$face} ||= {}; 515 my $info = $FACEINFO{$face} ||= { };
516 $info->{arc} = $o;
517
518 next if $face =~ /^blank.x11$|^empty.x11$/;
249 519
250 $info->{visibility} = $visibility if defined $visibility; 520 $info->{visibility} = $visibility if defined $visibility;
251 $info->{magicmap} = $magicmap if defined $magicmap; 521 $info->{magicmap} = $magicmap if defined $magicmap;
522 $info->{glyph} = $glyph if defined $glyph;
252 } 523 }
524
525 if (my $smooth = delete $o->{smoothface}) {
526 my %kv = split /\s+/, $smooth;
527 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
528 while (my ($face, $smooth) = each %kv) {
529 $FACEINFO{$smooth}{arc} = $o;
530
531 $FACEINFO{$face}{smooth} = $smooth;
532 $FACEINFO{$face}{smoothlevel} = $level;
533 }
534 }
253 } 535 }
254 } 536 }
255 } 537 }
256 } 538 }
257 539
258 sub process_trs { 540 sub process_trs {
259 while (@trs) { 541 while (my $job = $c_trs->get) {
260 my ($dir, $file) = @{pop @trs}; 542 my ($dir, $file) = @$job;
543 my $path = "$dir/$file";
544
545 my $trs;
546 if (0 > aio_load $path, $trs) {
547 warn "$path: $!, skipping.\n";
548 next;
549 }
550
551 $TRS .= $trs;
552 }
553 }
554
555 my %FILECACHE;
556
557 sub load_cached($;$) {
558 unless (exists $FILECACHE{$_[0]}) {
559 my $data;
560 if (0 < aio_load $_[0], $data) {
561 if ($_[1]) {
562 $data = eval { $_[1]->($data) };
563 warn "$_[0]: $@" if $@;
564 }
565 }
566
567 $FILECACHE{$_[0]} = $data;
568 }
569
570 $FILECACHE{$_[0]}
571 }
572
573 sub process_res {
574 while (my $job = $c_res->get) {
575 my ($dir, $file, $type) = @$job;
576
577 my $data;
578 aio_load "$dir/$file", $data;
579
580 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
581
582 utf8::decode $dir;
583 utf8::decode $file;
584
585 # a meta file for resources is now mandatory
586 unless (exists $meta->{$file}) {
587 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
588 next;
589 }
590
591 $meta = {
592 %{ $meta->{"" } || {} },
593 %{ $meta->{$file} || {} },
594 };
595
596 if ($meta->{license} =~ s/^#//) {
597 $meta->{license} = ({
598 "pd" => "Public Domain",
599 "gpl" => "GNU General Public License, version 3.0 or any later",
600 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
601 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
602 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
603 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
604 })->{$meta->{license}}
605 || warn "$dir/$file: license tag '$meta->{license}' not found.";
606 }
607
608 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
609 ($meta->{author} = $1) =~ s/_/ /g;
610 }
611
612 $file =~ s/\.res$//;
613 $file =~ s/\.(ogg|wav|jpg|png)$//;
614
615 substr $dir, 0, 1 + length $PATH, "";
616
617 if (my $filter = $meta->{cfutil_filter}) {
618 if ($filter eq "yaml2json") {
619 $data = JSON::XS::encode_json YAML::XS::Load $data;
620 } elsif ($filter eq "json2json") {
621 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
622 } elsif ($filter eq "perl2json") {
623 $data = eval $data; die if $@;
624 $data = JSON::XS::encode_json $data;
625 } else {
626 warn "$dir/$file: unknown filter $filter, skipping\n";
627 }
628 }
629
630 $RESOURCE{"$dir/$file"} = {
631 type => (exists $meta->{type} ? delete $meta->{type} : $type),
632 data => $data,
633 %$meta ? (meta => $meta) : (),
634 };
261 } 635 }
262 } 636 }
263 637
264 sub find_files; 638 sub find_files;
265 sub find_files { 639 sub find_files {
268 IO::AIO::aioreq_pri 4; 642 IO::AIO::aioreq_pri 4;
269 IO::AIO::aio_scandir $path, 4, sub { 643 IO::AIO::aio_scandir $path, 4, sub {
270 my ($dirs, $nondirs) = @_; 644 my ($dirs, $nondirs) = @_;
271 645
272 find_files "$path/$_" 646 find_files "$path/$_"
273 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 647 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
648
649 my $dir = $path;
650 substr $dir, 0, 1 + length $PATH, "";
274 651
275 for my $file (@$nondirs) { 652 for my $file (@$nondirs) {
653 if ($dir =~ /^music(?:\/|$)/) {
654 $c_res->put ([$path, $file, 3]) # FT_MUSIC
655 if $file =~ /\.(ogg)$/;
656
657 } elsif ($dir =~ /^sound(?:\/|$)/) {
658 $c_res->put ([$path, $file, 5]) # FT_SOUND
659 if $file =~ /\.(wav|ogg)$/;
660
661 } elsif ($dir =~ /^res(?:\/|$)/) {
662 if ($file =~ /\.(jpg|png)$/) {
663 $c_res->put ([$path, $file, 0]) # FT_FACE
664 } elsif ($file =~ /\.(res)$/) {
665 $c_res->put ([$path, $file, 6]) # FT_RSRC
666 } else {
667 $c_res->put ([$path, $file, undef]);
668 }
669
276 if ($file =~ /\.png$/) { 670 } elsif ($file =~ /\.png$/) {
277 push @png, "$path/$file"; 671 push @c_png, ["$path/$file", 0];
672
278 } elsif ($file =~ /\.trs$/) { 673 } elsif ($file =~ /\.trs$/) {
279 push @trs, [$path, $file]; 674 $c_trs->put ([$path, $file]);
675
280 } elsif ($file =~ /\.arc$/) { 676 } elsif ($file =~ /\.arc$/) {
281 push @arc, [$path, $file]; 677 $c_arc->put ([$path, $file]);
678
282 } else { 679 } else {
283 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 680 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
284 } 681 }
285 } 682 }
286 }; 683 };
684 }
685
686 sub generate_plurals {
687# use Lingua::EN::Inflect ();
688# Lingua::EN::Inflect::classical;
689# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
690# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
691#
692# for my $a (@ARC) {
693# my $name = $a->{name} || $a->{_name};
694#
695# next unless $a->{name_pl};
696# next if $a->{invisible};
697# next if $a->{is_floor};
698# next if $a->{no_pick};
699#
700# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
701# my $pl = $test =~ /^(?:eq|p:.)$/
702# ? $name
703# : Lingua::EN::Inflect::PL $name;
704#
705# if ($pl ne $a->{name_pl}) {
706# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
707# }
708# }
287 } 709 }
288 710
289 sub inst_arch($) { 711 sub inst_arch($) {
290 my (undef, $path) = @_; 712 my (undef, $path) = @_;
291 713
714 $PATH = $path;
715
716 print "\n",
292 print "installing '$path' to '$DATADIR'\n\n"; 717 "Installing '$path' to '$DATADIR'\n",
718 "\n",
719 "This can take a long time if you run this\n",
720 "for the first time or do not use --cache.\n",
721 "\n",
722 "Unless you run verbosely, all following warning\n",
723 "or error messages indicate serious problems.\n",
724 "\n";
293 725
294 if (!-d "$path/treasures") { 726 if (!-d "$path/treasures") {
295 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 727 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
296 exit 1 unless $FORCE; 728 exit 1 unless $FORCE;
297 } 729 }
298 730
731 print "scanning files...\n" if $VERBOSE;
732
299 find_files $path; 733 find_files $path;
734
735 my @a_arc = map +(async \&process_arc), 1..2;
736 my @a_res = map +(async \&process_res), 1..2;
737 my @a_trs = map +(async \&process_trs), 1..2;
738
300 IO::AIO::flush; 739 IO::AIO::flush;
301 740
302 $_->join for ( 741 $c_res->shutdown;
303 (async \&process_png), (async \&process_png), 742 $c_arc->shutdown;
304 (async \&process_trs), (async \&process_trs), 743 $c_trs->shutdown;
305 (async \&process_arc), (async \&process_arc),
306 );
307 744
745 print "start file scan, arc, res processing...\n" if $VERBOSE;
746
747 $_->join for @a_arc; # need to parse all archetypes before png processing
748
749 print "end arc, start png processing...\n" if $VERBOSE;
750
751 # eight png crunchers work fine for my 4x smp machine
752 my @a_png = map +(async \&process_png), 1..8;
753
754 $_->join for (@a_trs, @a_res, @a_png);
755
756 print "scanning done, processing results...\n" if $VERBOSE;
308 { 757 {
309 open my $fh, ">:utf8", "$DATADIR/animations~" 758 # remove path prefix from editor_folder
310 or die "$DATADIR/animations~: $!"; 759 $_->{editor_folder} =~ /^\x00/
311 print $fh join "", map $ANIM{$_}, sort keys %ANIM 760 and substr $_->{editor_folder}, 0, 2 + length $path, ""
761 for values %ARC;
762
763 print "resolving inheritance tree...\n" if $VERBOSE;
764 # resolve inherit
765 while () {
766 my $progress;
767 my $loop;
768
769 for my $o (values %ARC) {
770 for my $other (split /,/, $o->{inherit}) {
771 if (my $s = $ARC{$other}) {
772 if ($s->{inherit}) {
773 $loop = $s;
774 } else {
775 delete $o->{inherit};
776 my %s = %$s;
777 delete @s{qw(_name more name name_pl)};
778 %$o = ( %s, %$o );
779 ++$progress;
780 }
781 } else {
782 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
783 delete $ARC{$o->{_name}};
784 }
785 }
786 }
787
788 unless ($progress) {
789 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
790 if $loop;
791
792 last;
793 }
312 } 794 }
313 795
314 { 796 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
797 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
798
799 print "generating plurals...\n" if $VERBOSE;
800 generate_plurals;
801
802 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
315 open my $fh, ">:utf8", "$DATADIR/archetypes~" 803 open my $fh, ">:utf8", "$DATADIR/archetypes~"
316 or die "$DATADIR/archetypes~: $!"; 804 or die "$DATADIR/archetypes~: $!";
317 print $fh Crossfire::archlist_to_string \@ARC; 805 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
318 } 806 }
319 807
320 { 808 {
809 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
810 open my $fh, ">:utf8", "$DATADIR/treasures~"
811 or die "$DATADIR/treasures~: $!";
812 print $fh $TRS;
813 }
814
815 {
816 print "processing facedata...\n" if $VERBOSE;
321 while (my ($k, $v) = each %FACEINFO) { 817 while (my ($k, $v) = each %FACEINFO) {
322 $v->{data32} ||= delete $PNG32{$k}; 818 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
819 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
820
821 make_hash $k, $v->{data32}, $v->{hash32};
822 make_hash $k, $v->{data64}, $v->{hash64};
823
824 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
825 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
826
827 if (my $magicmap = $v->{magicmap}) {
828 $magicmap =~ y/A-Z_\-/a-z/d;
829 $v->{magicmap} = $COLOR{$magicmap};
323 } 830 }
324 831
832 my $stem = delete $v->{stem};
833 $v->{glyph} //= autoglyph $stem, $v;
834 utf8::encode $v->{glyph};
835 $v->{glyph} = (chr $v->{magicmap}) . $v->{glyph};
836
837 delete $v->{arc};
838 }
839
840 print "processing resources...\n" if $VERBOSE;
841 my $enc = JSON::XS->new->utf8->canonical->relaxed;
325 while (my ($k, $v) = each %FACEINFO) { 842 while (my ($k, $v) = each %RESOURCE) {
326 exists $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
327 843
328 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 844 if ($v->{meta} && $v->{meta}{datadir}) {
845 delete $RESOURCE{$k};
846
847 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
848
849 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
850 open my $fh, ">:raw", "$DATADIR/$k~"
851 or die "$DATADIR/$k~: $!";
852 syswrite $fh, $v->{data};
853 push @COMMIT, $k;
854
855 } else {
856 if ($v->{type} & 1) {
857 # prepend meta info
858
859 my $meta = $enc->encode ({
860 name => $k,
861 %{ $v->{meta} || {} },
862 });
863
864 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
865 }
866
867 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
329 } 868 }
869 }
330 870
871 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
872 scalar keys %FACEINFO,
873 scalar keys %ANIMINFO,
874 scalar keys %RESOURCE
875 if $VERBOSE;
876
331 open my $fh, ">:perlio", "$DATADIR/faces~" 877 open my $fh, ">:perlio", "$DATADIR/facedata~"
332 or die "$DATADIR/faces~: $!"; 878 or die "$DATADIR/facedata~: $!";
333 879
334 print $fh Storable::nfreeze \%FACEINFO; 880 print $fh nfreeze {
335 881 version => 2,
336 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 882 faceinfo => \%FACEINFO,
883 animinfo => \%ANIMINFO,
884 resource => \%RESOURCE,
337 } 885 };
338 886
339 for (qw(archetypes faces animations)) { 887 }
888
889 print "committing files...\n" if $VERBOSE;
890
891 for (qw(archetypes facedata treasures), @COMMIT) {
340 chmod 0644, "$DATADIR/$_~"; 892 chmod 0644, "$DATADIR/$_~";
341 rename "$DATADIR/$_~", "$DATADIR/$_"; 893 rename "$DATADIR/$_~", "$DATADIR/$_"
894 or die "$DATADIR/$_: $!";
342 } 895 }
343 896
344 die "--install-arch not fully implemented\n"; 897 print "archetype data installed successfully.\n";
345 } 898 }
346} 899}
347 900
348Getopt::Long::Configure ("bundling", "no_ignore_case"); 901Getopt::Long::Configure ("bundling", "no_ignore_case");
349GetOptions ( 902GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines